/*PLUGIN DATA*/
var wpStyletoolBaseSelector = '.wpoffcanvaspanels_panel.wpoffcanvaspanels_{theme-slug}';
var wpStyletoolSelectors = [];
wpStyletoolSelectors.push({
	title: 'Panel',
	key: 'panel',
	selector: '{bs}',
	properties: ['color', 'shadow', 'background', 'padding', 'border', 'text-align'],
	defaults: ['#000000', '', '#FFFFFF', '10px', '', '']
});
wpStyletoolSelectors.push({
	title: 'Links',
	key: 'links',
	selector: '{bs} a',
	properties: ['color', 'text-decoration', 'text-transform', 'font-weight', 'font-size'],
	defaults: ['#000000', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Links hover',
	key: 'links-hover',
	selector: '{bs} a:hover',
	properties: ['color', 'text-decoration', 'text-transform', 'font-weight', 'font-size'],
	defaults: ['#000000', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Headings',
	key: 'headings',
	selector: '{bs} h1, {bs} h2, {bs} h3, {bs} h4, {bs} h5, {bs} h6',
	properties: ['color', 'text-transform', 'font-size', 'text-shadow', 'border', 'text-align', 'margin', 'padding'],
	defaults: ['#000000', '', '', '', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Widgets',
	key: 'widgets',
	selector: '{bs} .widget',
	properties: ['background', 'border', 'padding', 'margin', 'color'],
	defaults: ['', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Form labels',
	key: 'form-labels',
	selector: '{bs} label',
	properties: ['color', 'text-decoration', 'text-transform', 'font-weight', 'font-size', 'text-shadow'],
	defaults: ['#000000', '', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Form inputs',
	key: 'form-inputs',
	selector: '{bs} textarea, {bs} input[type=text]',
	properties: ['background', 'color', 'border', 'border-radius', 'shadow', 'padding', 'margin', 'text-transform', 'text-shadow'],
	defaults: ['', '', '', '', '', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Form inputs focus',
	key: 'form-inputs-focus',
	selector: '{bs} textarea:focus, {bs} input[type=text]:focus',
	properties: ['background', 'color', 'border', 'border-radius', 'shadow'],
	defaults: ['', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Form buttons',
	key: 'form-buttons',
	selector: '{bs} input[type=reset], {bs} input[type=button], {bs} input[type=submit], {bs} button',
	properties: ['background', 'color', 'border', 'border-radius', 'shadow', 'padding', 'margin', 'text-transform', 'text-shadow'],
	defaults: ['', '', '', '', '', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Form buttons hover',
	key: 'form-buttons-hover',
	selector: '{bs} input[type=reset]:hover, {bs} input[type=button]:hover, {bs} input[type=submit]:hover, {bs} button:hover',
	properties: ['background', 'color', 'border', 'border-radius', 'shadow'],
	defaults: ['', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Toggle button',
	key: 'toggle-button',
	selector: '.wpoffcanvaspanels_button{theme-class} span',
	properties: ['background', 'color', 'border', 'border-radius', 'shadow', 'padding', 'margin', 'text-transform', 'text-shadow'],
	defaults: ['', '', '', '', '', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Toggle button hover',
	key: 'toggle-button-hover',
	selector: '.wpoffcanvaspanels_button{theme-class}:hover span',
	properties: ['background', 'color', 'border', 'border-radius', 'shadow'],
	defaults: ['', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Close button',
	key: 'close-button',
	selector: '{bs} .wpoffcanvaspanels_close',
	properties: ['background', 'color', 'border', 'border-radius', 'shadow', 'padding', 'margin', 'text-transform', 'text-shadow'],
	defaults: ['', '', '', '', '', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Close button hover',
	key: 'close-button-hover',
	selector: '{bs} .wpoffcanvaspanels_close:hover',
	properties: ['background', 'color', 'border', 'border-radius', 'shadow'],
	defaults: ['', '', '', '', '']
});
wpStyletoolSelectors.push({
	title: 'Misc',
	key: 'misc',
	selector: '{empty}',
	properties: ['custom'],
	defaults: ['']
});
var wpStyletoolPreviewCss = 'preview.css';
var wpStyletoolPreviewHTML = '<div style="width:100%">';
wpStyletoolPreviewHTML += '<h1>Heading</h1>';
wpStyletoolPreviewHTML += '<span class="wpoffcanvaspanels_close">x</span>';
wpStyletoolPreviewHTML += '<div class="widget"><p>Proin pretium rutrum erat, nec gravida quam lobortis quis. Pellentesque imperdiet erat feugiat magna gravida, nec bibendum magna laoreet. Vivamus id lacus lacus. Morbi eu feugiat nisi. Nunc egestas quis lacus in rhoncus. Mauris consectetur mollis vulputate.</p></div>';
wpStyletoolPreviewHTML += '<div class="widget"><p>Proin pretium rutrum erat, nec gravida quam lobortis quis. Pellentesque imperdiet erat feugiat magna gravida, nec bibendum magna laoreet. Vivamus id lacus lacus. Morbi eu feugiat nisi. Nunc egestas quis lacus in rhoncus. Mauris consectetur mollis vulputate.</p></div>';
wpStyletoolPreviewHTML += '<p><a href="#">Link preview</a></p>';
wpStyletoolPreviewHTML += '<h2>Form preview</h2>';
wpStyletoolPreviewHTML += '<form><label>Form label</label><br /><input type="text" value="Form input" /><br /><input type="submit" value="Form button"></form>';
wpStyletoolPreviewHTML += '</div>';

/*FOUR VALUE FIELD*/
(function($) {

	$.fn.wpStyleToolFourValueField = function(classes, fieldLabels, value) {
		this.addClass('fourvalue-field');
		var hiddenInput = $('<input type="hidden" class="' + classes + '" value="' + value + '" />');
		if (value == '') {
			value = '0 0 0 0';
		}
		var values = value.replace(/px/g, '');
		values = values.split(' ');
		switch (values.length) {
			case 0:
				values = [0, 0, 0, 0];
				break;
			case 1:
				values = [values[0], values[0], values[0], values[0]];
				break;
			case 2:
				values = [values[0], values[1], values[0], values[1]];
				break;
			case 3:
				values = [values[0], values[1], values[2], values[1]];
				break;
		}
		for (var i = 0; i < fieldLabels.length; i++) {
			var holder = $('<div class="fourvalue-field-holder" />');
			var label = '<label>' + fieldLabels[i] + '</label>';
			var v = values[i];
			var cls = 'fourvalue-field-' + i;
			var field = '<input type="number" value="' + v + '" step="1" min="0" class="' + cls + '" />';
			holder.append(label);
			holder.append(field);
			this.append(holder);
		}
		this.append(hiddenInput);
		var allInputs = this.find('input[type="number"]');
		allInputs.change(function(e) {
			var newValue = '';
			allInputs.each(function(index, element) {
				if (index == 0) {
					newValue += $(element).val() + 'px';
				} else {
					newValue += ' ' + $(element).val() + 'px';
				}
			});
			hiddenInput.val(newValue);
			hiddenInput.trigger('change');
		});
	}

}(jQuery));

/*STYLE TOOL PLUGIN*/
(function($) {

	$.wpStyleToolField = {};
	$.wpStyleToolValue = {};

	$.wpStyleToolField.border = function(value) {
		if (!value || value == '') {
			value = '0px solid #000000';
		}
		var perSideValue = value.split(',');
		if (perSideValue.length == 1) {
			perSideValue[1] = perSideValue[0];
			perSideValue[2] = perSideValue[0];
			perSideValue[3] = perSideValue[0];
		}
		var field = $('<div />');
		var hiddenInput = $('<input type="hidden" class="styletool_border styletool_field" value="' + value + '" />');
		field.append(hiddenInput);
		var sides = ['top', 'right', 'bottom', 'left'];
		var borderStyles = ['solid', 'dotted', 'dashed', 'double', 'groove', 'ridge', 'inset', 'outset'];
		for (var i = 0; i < sides.length; i++) {
			var values = perSideValue[i].split(' ');
			var sizeValue = values[0].replace('px', '');
			var styleValue = values[1];
			var colorValue = values[2];
			var sideField = $('<div class="border-' + sides[i] + '" />');
			sideField.append('<label>' + sides[i] + '</label>');
			sideField.append('<input class="border-size" type="number" value="' + sizeValue + '" step="1" min="0" />px ');
			var borderStyleField = '<select class="border-style">';
			for (var j = 0; j < borderStyles.length; j++) {
				if (styleValue == borderStyles[j]) {
					borderStyleField += '<option selected="selected">' + borderStyles[j] + '</option>';
				} else {
					borderStyleField += '<option>' + borderStyles[j] + '</option>';
				}
			}
			borderStyleField += '</select>';
			sideField.append(borderStyleField);
			sideField.append('<input type="text" value="' + colorValue + '" class="styletool-colorpicker border-color" />');
			field.append(sideField);
		}
		field.find('input:not(.styletool_field), select').change(function() {
			var newValue = '';
			for (var i = 0; i < sides.length; i++) {
				var side = sides[i];
				var sideHolder = field.find('.border-' + side);
				var sideSize = sideHolder.find('.border-size').val();
				var sideStyle = sideHolder.find('.border-style').val();
				var sideColor = sideHolder.find('.border-color').val();
				if (i != 0) {
					newValue += ', ';
				}
				newValue += sideSize + 'px ' + sideStyle + ' ' + sideColor;
			}
			hiddenInput.val(newValue);
			hiddenInput.trigger('change');
		});
		return field;
	}
	$.wpStyleToolValue.border = function(propertie, value, element) {
		var output = '';
		var split = value.split(',');
		if (split.length == 1) {
			output += '\t border: ' + value + '; \n';
		} else {
			var sides = ['top', 'right', 'bottom', 'left'];
			for (var i = 0; i < sides.length; i++) {
				output += '\t border-' + sides[i] + ': ' + split[i] + '; \n';
			}
		}
		return output;
	}

	$.wpStyleToolField.color = function(value) {
		if (value == '') {
			value = '#000000';
		}
		return '<input type="text" value="' + value + '" class="styletool-colorpicker styletool_color styletool_field" />';
	}

	$.wpStyleToolField.background = function(value) {
		var orientation = 'vertical';
		if (value.indexOf('horizontal') !== -1) {
			orientation = 'horizontal';
		}
		if (value == '') {
			value = '0% #FFFFFF';
		}
		var gradientValue = value.replace(/ horizontal/g, '');
		gradientValue = gradientValue.replace(/horizontal, /g, '');
		gradientValue = gradientValue.replace(/ vertical/g, '');
		gradientValue = gradientValue.replace(/vertical, /g, '');
		if (gradientValue.length == 7) {
			gradientValue = '0% ' + gradientValue;
		}
		var field = $('<div />');
		var hiddenInput = $('<input type="hidden" class="styletool_background styletool_field" value="' + value + '" />');
		field.append(hiddenInput);
		var gradientField = $('<div class="gradient-field" />');
		gradientField.ClassyGradient({
			orientation: orientation,
			gradient: gradientValue,
			onChange: function(stringGradient, orientation) {
				clearTimeout(window.gradientChangeTimer);
				window.gradientChangeTimer = setTimeout(function() {
					hiddenInput.val(orientation + ', ' + stringGradient);
					hiddenInput.trigger('change');
				}, 200);
			}
		});
		field.append(gradientField);
		setTimeout(function() {
			gradientField.data('ClassyGradient').update();
		}, 75);
		if (orientation == 'horizontal') {
			var orientationField = $('<label>Orientation</label><select><option value="vertical">Vertical</option><option selected="selected" value="horizontal">Horizontal</option></select>');
		} else {
			var orientationField = $('<label>Orientation</label><select><option selected="selected" value="vertical">Vertical</option><option value="horizontal">Horizontal</option></select>');
		}
		field.append(orientationField);
		field.find('select').change(function() {
			var val = $(this).val();
			gradientField.data('ClassyGradient').setOrientation(val);
			gradientField.data('ClassyGradient')._renderCanvas();
		});
		return field;
	}
	$.wpStyleToolValue.background = function(propertie, value, element) {
		var gradientField = element.parent().find('.gradient-field');
		var data = gradientField.data('ClassyGradient');
		var arr = data.getArray();
		if (arr.length == 1) {
			return '\t ' + propertie + ': ' + arr[0][1] + '; \n';
		}
		return data.getCSS() + '\n';
	}

	$.wpStyleToolField.text_shadow = function(value) {
		var valueData = value.split(' ');
		var horValue = valueData.length >= 1 ? parseInt(valueData[0].replace('px', '')) : 0;
		if (value == '') {
			horValue = 0;
		}
		var verValue = valueData.length >= 2 ? parseInt(valueData[1].replace('px', '')) : 0;
		var blurValue = valueData.length >= 3 ? parseInt(valueData[2].replace('px', '')) : 0;
		var colorValue = valueData.length >= 4 ? valueData[3] : '#000000';
		var field = $('<div />');
		var hiddenInput = $('<input type="hidden" class="styletool_text_shadow styletool_field" value="' + value + '" />');
		var columnHolder = $('<div style="overflow:hidden;"></div>');
		var horizontalField = '<div class="two-column-div"><label>Horizontal position</label><input class="text-shadow-horizontal text-shadow-part" type="number" value="' + horValue + '" step="1" min="-100" /></div>';
		var verticalField = '<div class="two-column-div"><label>Vertical position</label><input class="text-shadow-vertical text-shadow-part" type="number" value="' + verValue + '" step="1" min="-100" /></div>';
		var blurField = '<div class="two-column-div"><label>Blur</label><input class="text-shadow-blur text-shadow-part" type="number" value="' + blurValue + '" step="1" min="0" /></div>';
		var colorField = '<div class="two-column-div"><label>Color</label><input type="text" value="' + colorValue + '" class="styletool-colorpicker text-shadow-part text-shadow-color" /></div>';
		field.append(hiddenInput);
		columnHolder.append(horizontalField);
		columnHolder.append(verticalField);
		columnHolder.append(blurField);
		columnHolder.append(colorField);
		field.append(columnHolder);
		field.find('.text-shadow-part').change(function() {
			var hor = field.find('.text-shadow-horizontal').val() + 'px ';
			var ver = field.find('.text-shadow-vertical').val() + 'px ';
			var blur = field.find('.text-shadow-blur').val() + 'px ';
			var color = field.find('.text-shadow-color').val();
			field.find('.styletool_text_shadow').val(hor + ver + blur + color);
			field.find('.styletool_text_shadow').trigger('change');
		});
		return field;
	}

	$.wpStyleToolField.text_transform = function(value) {
		var options = [{
			v: 'none',
			t: 'None'
		}, {
			v: 'capitalize',
			t: 'Capitalize'
		}, {
			v: 'uppercase',
			t: 'Uppercase'
		}, {
			v: 'lowercase',
			t: 'Lowercase'
		}];
		var output = '<select class="styletool_text_transform styletool_field">';
		for (var i = 0; i < options.length; i++) {
			var option = options[i];
			if (option.v == value) {
				output += '<option selected="selected" value="' + option.v + '">' + option.t + '</option>';
			} else {
				output += '<option value="' + option.v + '">' + option.t + '</option>';
			}
		}
		output += '</select>';
		return output;
	}

	$.wpStyleToolField.text_decoration = function(value) {
		var options = [{
			v: 'none',
			t: 'None'
		}, {
			v: 'underline',
			t: 'Underline'
		}, {
			v: 'line-through',
			t: 'Line through'
		}];
		var output = '<select class="styletool_text_decoration styletool_field">';
		for (var i = 0; i < options.length; i++) {
			var option = options[i];
			if (option.v == value) {
				output += '<option selected="selected" value="' + option.v + '">' + option.t + '</option>';
			} else {
				output += '<option value="' + option.v + '">' + option.t + '</option>';
			}
		}
		output += '</select>';
		return output;
	}

	$.wpStyleToolField.shadow = function(value) {
		var valueData = value.split(' ');
		var horValue = valueData.length >= 1 ? parseInt(valueData[0].replace('px', '')) : 0;
		if (value == '') {
			horValue = 0;
		}
		var verValue = valueData.length >= 2 ? parseInt(valueData[1].replace('px', '')) : 0;
		var blurValue = valueData.length >= 3 ? parseInt(valueData[2].replace('px', '')) : 0;
		var spreadValue = valueData.length >= 4 ? parseInt(valueData[3].replace('px', '')) : 0;
		var colorValue = valueData.length >= 5 ? valueData[4] : '#000000';
		var typeValue = valueData.length >= 6 ? valueData[5] : 'outside';

		var field = $('<div />');
		var hiddenInput = $('<input type="hidden" class="styletool_shadow styletool_field" value="' + value + '" />');
		var columnHolder = $('<div style="overflow:hidden;"></div>');
		var horizontalField = '<div class="two-column-div"><label>Horizontal position</label><input class="shadow-horizontal shadow-part" type="number" value="' + horValue + '" step="1" min="-100" /></div>';
		var verticalField = '<div class="two-column-div"><label>Vertical position</label><input class="shadow-vertical shadow-part" type="number" value="' + verValue + '" step="1" min="-100" /></div>';
		var blurField = '<div class="two-column-div"><label>Blur</label><input class="shadow-blur shadow-part" type="number" value="' + blurValue + '" step="1" min="0" /></div>';
		var spreadField = '<div class="two-column-div"><label>Spread</label><input class="shadow-spread shadow-part" type="number" value="' + spreadValue + '" step="1" min="0" /></div>';
		var colorField = '<label>Color</label><input type="text" value="' + colorValue + '" class="styletool-colorpicker shadow-part shadow-color" />';
		if (typeValue == 'outside') {
			var typeField = '<label>Type</label><select class="shadow-part shadow-type"><option selected="selected" value="outside">Outside</option><option value="inside">Inside</option></select>';
		} else {
			var typeField = '<label>Type</label><select class="shadow-part shadow-type"><option value="outside">Outside</option><option selected="selected" value="inside">Inside</option></select>';
		}
		field.append(hiddenInput);
		columnHolder.append(horizontalField);
		columnHolder.append(verticalField);
		columnHolder.append(blurField);
		columnHolder.append(spreadField);
		field.append(columnHolder);
		field.append(colorField);
		field.append(typeField);
		field.find('.shadow-part').change(function() {
			var hor = field.find('.shadow-horizontal').val() + 'px ';
			var ver = field.find('.shadow-vertical').val() + 'px ';
			var blur = field.find('.shadow-blur').val() + 'px ';
			var spread = field.find('.shadow-spread').val() + 'px ';
			var color = field.find('.shadow-color').val();
			var type = field.find('.shadow-type').val();
			if (type == 'outside') {
				type = '';
			} else {
				type = ' inset';
			}
			field.find('.styletool_shadow').val(hor + ver + blur + spread + color + type);
			field.find('.styletool_shadow').trigger('change');
		});
		return field;
		return '';
	}
	$.wpStyleToolValue.shadow = function(propertie, value, element) {
		var output = '';
		output += '\t -moz-box-shadow: ' + value + '; \n';
		output += '\t -webkit-box-shadow: ' + value + '; \n';
		output += '\t box-shadow: ' + value + '; \n';
		return output;
	}

	$.wpStyleToolField.border_radius = function(value) {
		var field = $('<div></div>');
		var classes = 'styletool_border_radius styletool_field';
		var labels = ['Top left', 'Top right', 'Bottom right', 'Bottom left'];
		field.wpStyleToolFourValueField(classes, labels, value);
		return field;
	}
	$.wpStyleToolValue.border_radius = function(propertie, value, element) {
		var output = '';
		output += '\t -moz-' + propertie + ': ' + value + '; \n';
		output += '\t -webkit-' + propertie + ': ' + value + '; \n';
		output += '\t ' + propertie + ': ' + value + '; \n';
		return output;
	}

	$.wpStyleToolField.padding = function(value) {
		var field = $('<div></div>');
		var classes = 'styletool_padding styletool_field';
		var labels = ['Top', 'Right', 'Bottom', 'Left'];
		field.wpStyleToolFourValueField(classes, labels, value);
		return field;
	}

	$.wpStyleToolField.margin = function(value) {
		var field = $('<div></div>');
		var classes = 'styletool_margin styletool_field';
		var labels = ['Top', 'Right', 'Bottom', 'Left'];
		field.wpStyleToolFourValueField(classes, labels, value);
		return field;
	}

	$.wpStyleToolField.text_align = function(value) {
		var options = [{
			v: 'left',
			t: 'Left'
		}, {
			v: 'center',
			t: 'Center'
		}, {
			v: 'right',
			t: 'right'
		}];
		var output = '<select class="styletool_text_align styletool_field">';
		for (var i = 0; i < options.length; i++) {
			var option = options[i];
			if (option.v == value) {
				output += '<option selected="selected" value="' + option.v + '">' + option.t + '</option>';
			} else {
				output += '<option value="' + option.v + '">' + option.t + '</option>';
			}
		}
		output += '</select>';
		return output;
	}

	$.wpStyleToolField.font_size = function(value) {
		if (value == '') {
			value = 12;
		}
		return '<input class="styletool_field styletool_font_size" type="number" value="' + value + '" step="1" min="8" />';
	}
	$.wpStyleToolValue.font_size = function(propertie, value, element) {
		return '\t ' + propertie + ': ' + value + 'px; \n';
	}

	$.wpStyleToolField.font_weight = function(value) {
		var options = [{
			v: 'normal',
			t: 'Normal'
		}, {
			v: 'bold',
			t: 'Bold'
		}];
		var output = '<select class="styletool_font_weight styletool_field">';
		for (var i = 0; i < options.length; i++) {
			var option = options[i];
			if (option.v == value) {
				output += '<option selected="selected" value="' + option.v + '">' + option.t + '</option>';
			} else {
				output += '<option value="' + option.v + '">' + option.t + '</option>';
			}
		}
		output += '</select>';
		return output;
	}

	$.wpStyleToolField.line_height = function(value) {
		if (value == '') {
			value = 12;
		}
		return '<input class="styletool_field styletool_line_height" type="number" value="' + value + '" step="1" min="8" />';
	}
	$.wpStyleToolValue.line_height = function(propertie, value, element) {
		return '\t ' + propertie + ': ' + value + 'px; \n';
	}

	$.wpStyleToolField.width = function(value) {
		if (value == '') {
			value = 0;
		}
		return '<input class="styletool_field styletool_width" type="number" value="' + value + '" step="1" min="0" />';
	}
	$.wpStyleToolValue.width = function(propertie, value, element) {
		return '\t ' + propertie + ': ' + value + 'px; \n';
	}

	$.wpStyleToolField.height = function(value) {
		if (value == '') {
			value = 0;
		}
		return '<input class="styletool_field styletool_height" type="number" value="' + value + '" step="1" min="0" />';
	}
	$.wpStyleToolValue.height = function(propertie, value, element) {
		return '\t ' + propertie + ': ' + value + 'px; \n';
	}

	$.wpStyleToolField.custom = function(value) {
		return '<p class="description">You can add custom css below, only use this if you understand css!</p><textarea class="styletool_field styletool_custom">' + value + '</textarea>';
	}
	$.wpStyleToolValue.custom = function(propertie, value, element) {
		return value;
	}

	function create_propertie_field(propertie, value) {
		var fieldFunction = propertie.replace(/-/g, '_');
		var field = $.wpStyleToolField[fieldFunction](value);
		var fieldHolder = $('<div class="field-holder ' + propertie + '" />');
		if (!value || value == '') {
			fieldHolder.append('<div class="field-header"><input type="checkbox" class="field_enable_toggle" /> <label>' + propertie + '</label></div>');
			var fieldDiv = $('<div class="disabled" style="display:none;" />');
		} else {
			fieldHolder.append('<div class="field-header"><input checked="checked" type="checkbox" class="field_enable_toggle" /> <label>' + propertie + '</label></div>');
			var fieldDiv = $('<div />');
		}
		fieldHolder.append(fieldDiv);
		fieldDiv.append(field);
		fieldHolder.find('.field_enable_toggle').click(function(e) {
			e.stopPropagation();
		});
		fieldHolder.find('.field_enable_toggle').change(function(e) {
			var div = $(this).parent().parent().find('> div');
			if ($(this).is(':checked')) {
				div.removeClass('disabled');
			} else {
				div.addClass('disabled');
			}
			onStyleChange(null);
		});
		return fieldHolder;
	}

	function create_selector_section(selector, data) {
		var section = $('<div class="selector-section" />');
		section.data('selector', selector.selector);
		section.append('<h3>' + selector.title + '</h3>');
		var fieldHolder = $('<div class="selector-section-fields-holder" />');
		section.append(fieldHolder);
		var selectorData = data[selector.key];
		for (var i = 0; i < selector.properties.length; i++) {
			var propertie = selector.properties[i];
			var value = selector.defaults[i];
			if (selectorData && typeof selectorData[propertie] !== 'undefined') {
				value = selectorData[propertie];
			}
			fieldHolder.append(create_propertie_field(propertie, value));
		}
		return section;
	}

	/*Changes*/
	var _isDirty;
	function onStyleChange(e) {
		_isDirty = true;
		var css = renderStyle(true);
		var iframeHead = $('#styletool-preview iframe').contents().find('head');
		iframeHead.find('#dynamicstyles').remove();
		iframeHead.append('<style id="dynamicstyles">' + css + '</style>');
		$('#styletool-preview iframe').height(0);
		var iframeHeight = $('#styletool-preview iframe').contents().find("body").outerHeight(true);
		$('#styletool-preview iframe').height(iframeHeight + 50);
	}
	function isDirty() {
		return _isDirty;
	}

	/*Style render*/
	var baseSelector;
	var themeSlug;
	function renderStyle(noBase) {
		var _baseSelector = baseSelector;
		var _themeClass = '.wpoffcanvaspanels_' + themeSlug;
		if (noBase) {
			_baseSelector = 'body > div';
		}
		var output = '';
		for (var i = 0; i < wpStyletoolSelectors.length; i++) {
			var currSelector = wpStyletoolSelectors[i];
			var currSelectorElement = $('.selector-section:eq(' + i + ')');
			var selector = currSelector.selector.replace(/{bs}/g, _baseSelector);
			selector = selector.replace(/{theme-class}/g, _themeClass);
			if (selector == '{empty}') {
				selector = '';
			} else {
				output += '/*' + currSelector.title + '*/ \n';
				output += selector + ' {\n';
			}
			for (var j = 0; j < currSelector.properties.length; j++) {
				var propertie = currSelector.properties[j];
				var formattedPropertie = propertie.replace(/-/g, '_');
				var fieldClass = '.styletool_' + formattedPropertie;
				var fieldElement = currSelectorElement.find(fieldClass);
				if (fieldElement.length > 0) {
					var fieldIsActive = fieldElement.closest('.field-holder').find('.field_enable_toggle').is(':checked');
					if (fieldIsActive) {
						var fieldValue = fieldElement.val();
						if (fieldValue) {
							if ($.wpStyleToolValue[formattedPropertie]) {
								output += $.wpStyleToolValue[formattedPropertie](propertie, fieldValue, fieldElement);
							} else {
								output += '\t ' + propertie + ': ' + fieldValue + '; \n'
							}
						}
					}
				}
			}
			if (selector == '') {
				output += '\n\n';
			} else {
				output += '} \n\n';
			}
		}
		return output;
	}

	/*Array data*/
	function getArrayData() {
		var output = {};
		for (var i = 0; i < wpStyletoolSelectors.length; i++) {
			var currSelector = wpStyletoolSelectors[i];
			var currSelectorElement = $('.selector-section:eq(' + i + ')');
			var currSelectorData = {};
			for (var j = 0; j < currSelector.properties.length; j++) {
				var propertie = currSelector.properties[j];
				var fieldClass = '.styletool_' + propertie.replace(/-/g, '_');
				var fieldElement = currSelectorElement.find(fieldClass);
				if (fieldElement.length > 0) {
					var fieldIsActive = fieldElement.closest('.field-holder').find('.field_enable_toggle').is(':checked');
					if (fieldIsActive) {
						var fieldValue = fieldElement.val();
					} else {
						var fieldValue = '';
					}
					currSelectorData[propertie] = fieldValue;
				}
			}
			output[currSelector.key] = currSelectorData;
		}
		return output;
	}

	$.fn.wpStyleTool = function(themeData) {
		if (!themeData.data) {
			themeData.data = {};
		}
		//baseSelector
		themeSlug = themeData.slug;
		baseSelector = wpStyletoolBaseSelector.replace('{theme-slug}', themeSlug);
		//create container
		var container = $('<div id="styletool" />');
		this.append(container);
		//preview
		var preview = $('<div id="styletool-preview" />');
		preview.append('<h3>Preview</h3><p class="description">This preview is not exactly how it will look on your website it is just a global preview, theme dependend styles are not included in the preview.</p>');
		preview.append('<iframe>');
		container.append(preview);
		setTimeout(function() {
			$('#styletool-preview iframe').contents().find('body').html(wpStyletoolPreviewHTML);
			$('#styletool-preview iframe').contents().find('head').append('<link rel="stylesheet" href="' + styletoolPluginURL + wpStyletoolPreviewCss + '" type="text/css" />');
			var iframeHeight = $('#styletool-preview iframe').contents().find("body").height();
			iframeHeight += 100;
			$('#styletool-preview iframe').height(iframeHeight);
			onStyleChange(null);
			setTimeout(function() {
				_isDirty = false;
			}, 500);
		}, 50);
		//create form
		var formHolder = $('<div id="styletool-form" />');
		container.prepend(formHolder);
		for (var i = 0; i < wpStyletoolSelectors.length; i++) {
			var currSelector = wpStyletoolSelectors[i];
			formHolder.append(create_selector_section(currSelector, themeData.data));
		}
		//accordion
		$('#styletool-form').accordion({
			animate: false,
			collapsible: true,
			header: 'div > h3',
			active: false
		});
		$('#styletool-form .selector-section-fields-holder').accordion({
			animate: false,
			collapsible: true,
			header: 'div.field-header',
			active: false
		});
		//colorpickers
		var colorPickers = $('#styletool-form .styletool-colorpicker');
		colorPickers.spectrum({
			showInput: true,
			showAlpha: true
		});
		
		//change events
		$('#styletool-form .styletool_field').change(onStyleChange);
		//return
		return {
			isDirty: isDirty,
			render: renderStyle,
			getData: getArrayData
		};
	};

}(jQuery));

/*EVENTS ETC*/
jQuery(document).ready(function() {
	/**
	 * Do ajax save
	 */
	function doAjaxCall(action, data, callback) {
		jQuery('#wp-styletool-loader').show();
		var dataObj = {
			action: action
		};
		for (var key in data) {
			dataObj[key] = data[key];
		}
		jQuery.post(ajaxurl, dataObj, function(result) {
			jQuery('#wp-styletool-loader').hide();
			if (callback) {
				callback(result);
			}
		});
	}

	/**
	 * Close modal
	 */
	function closeModal() {
		jQuery('#style-tool-modal').hide();
		jQuery('#style-tool-modal .media-frame-content').empty();
		jQuery('#style-tool-modal .cancel-button').unbind('click');
		jQuery('#style-tool-modal .media-modal-close').unbind('click');
	}

	/**
	 * Open modal
	 */
	function openModal(data) {
		var _data = data;
		var api = jQuery('#style-tool-modal .media-frame-content').wpStyleTool(data);
		jQuery('#style-tool-modal').show();
		jQuery('#style-tool-modal .media-frame-title h1').text('Style Editor: ' + data.title);
		jQuery('#style-tool-modal .cancel-button, #style-tool-modal .media-modal-close').click(function(e) {
			e.preventDefault();
			if (api.isDirty()) {
				var really = confirm("Are you sure? all changes will be lost!");
				if (really) {
					closeModal();
				}
			} else {
				closeModal();
			}
		});
		jQuery('#style-tool-modal .save-button, #style-tool-modal .save-close-button').click(function(e) {
			var isSaveAndClose = jQuery(this).hasClass('save-close-button');
			e.preventDefault();
			var data = {
				'theme_slug': _data.slug,
				'theme_css': api.render(),
				'theme_data': api.getData()
			};
			doAjaxCall('wpoffcanvaspanels_styletool_save_theme', data, function(result) {
				result = jQuery.parseJSON(result);
				if (result.error) {
					alert(result.message);
				} else {
					if (isSaveAndClose) {
						reloadTable();
					}
				}
			});
		});
	}

	/**
	 *Reload table
	 */
	function reloadTable() {
		jQuery('#wp-styletool-loader').show();
		window.location = window.location;
	}

	//Add new theme button
	jQuery('#style-tool-new-theme').click(function(e) {
		e.preventDefault();
		var themeTitle = prompt('Theme title', '');
		if (themeTitle) {
			var data = {
				'theme_title': themeTitle
			};
			doAjaxCall('wpoffcanvaspanels_styletool_add_new_theme', data, function(result) {
				result = jQuery.parseJSON(result);
				if (result.error) {
					alert(result.message);
				} else {
					reloadTable();
				}
			});
		}
	});

	//Export buttons
	jQuery('#style-tool-table .export-button').click(function(e) {
		e.preventDefault();
		var tr = jQuery(this).closest('tr');
		var slug = tr.data('slug');
		var data = {
			'theme_slug': slug
		};
		doAjaxCall('wpoffcanvaspanels_styletool_export_theme', data, function(result) {
			result = jQuery.parseJSON(result);
			if (result.error) {
				alert(result.message);
			} else {
				var saveForm = document.createElement('form');
				saveForm.target = '_blank';
				saveForm.method = 'POST';
				saveForm.action = result.link;
				var saveFilenameInput = document.createElement('input');
				saveFilenameInput.type = 'text';
				saveFilenameInput.name = 'filename';
				saveFilenameInput.value = slug + '.wpse';
				saveForm.appendChild(saveFilenameInput);
				var saveDataInput = document.createElement('input');
				saveDataInput.type = 'text';
				saveDataInput.name = 'data';
				saveDataInput.value = result.data;
				saveForm.appendChild(saveDataInput);
				var saveCssInput = document.createElement('input');
				saveCssInput.type = 'text';
				saveCssInput.name = 'css';
				saveCssInput.value = result.css;
				saveForm.appendChild(saveCssInput);
				document.body.appendChild(saveForm);
				saveForm.submit();
				document.body.removeChild(saveForm);
			}
		});
	});

	//Delete buttons
	jQuery('#style-tool-table .delete-button').click(function(e) {
		e.preventDefault();
		var tr = jQuery(this).closest('tr');
		var really = confirm("Are you sure?");
		if (really) {
			var data = {
				'theme_slug': tr.data('slug')
			};
			doAjaxCall('wpoffcanvaspanels_styletool_remove_theme', data, function(result) {
				result = jQuery.parseJSON(result);
				if (result.error) {
					alert(result.message);
				} else {
					reloadTable();
				}
			});
		}
	});

	//Copy buttons
	jQuery('#style-tool-table .copy-button').click(function(e) {
		e.preventDefault();
		var tr = jQuery(this).closest('tr');
		var themeTitle = prompt('Theme title', '');
		if (themeTitle) {
			var data = {
				'theme_slug': tr.data('slug'),
				'new_theme_title': themeTitle
			};
			doAjaxCall('wpoffcanvaspanels_styletool_copy_theme', data, function(result) {
				result = jQuery.parseJSON(result);
				if (result.error) {
					alert(result.message);
				} else {
					reloadTable();
				}
			});
		}
	});

	//Edit buttons
	jQuery('#style-tool-table .edit-button').click(function(e) {
		e.preventDefault();
		var tr = jQuery(this).closest('tr');
		var data = {
			'theme_slug': tr.data('slug')
		};
		doAjaxCall('wpoffcanvaspanels_styletool_get_theme', data, function(result) {
			result = jQuery.parseJSON(result);
			if (result.error) {
				alert(result.message);
			} else {
				openModal(result);
			}
		});
	});
});